/*
 * MODBUS.h
 *
 * Created: 11.04.2022 13:22:30
 *  Author: tomas.viktora
 */ 

 #include <avr/io.h>
 #include <avr/interrupt.h>
 #include <util/delay.h>
 #include <stdio.h>
 #include <string.h>
 #include "ioctrl.h"
 #include "iodef.h"
 #include "std.h"


#ifndef MODBUS_H_
#define MODBUS_H_

#define SLAVE_ID 0x01 // prozatm, pozdji zakomentovat

#define ID_BYTE 0
#define FUNCTION_BYTE 1
#define LENGHT_BYTE 2
#define DATA_START_BYTE 2

#define DO_SET_ON 0xFF00
#define DO_SET_OFF 0x0000

#define READ_DO 0x01
#define READ_DI 0x02
#define READ_AO 0x03
#define READ_AI 0x04
#define WRITE_SINGLE_DO 0x05
#define WRITE_SINGLE_AO 0x06
#define WRITE_MULTIPLE_DO 0x0F
#define WRITE_MULTIPLE_AO 0x10

#define NO_OF_STATIC_BYTES 2
#define NO_OF_CRC_BYTE 2

volatile uchar tx_data[32];
volatile uchar rx_data[32];
volatile uint cnt_rx;
volatile uint cnt_tx;
uchar digital_in[4];
uchar digital_out[4];
uint16_t analog_in[8];
uint16_t analog_out[8];

uint is_change_out;

#endif /* MODBUS_H_ */

uint16_t check_crc(uint data_length, uchar *data);
uint make_int(uchar crc_HB, uchar crc_LB);
void send_task(uchar function_code, uchar data_length, uchar *data);
void flush_rx_data(void);
void flush_tx_data(void);
void recieve_task(void);